# Generated by Django 4.2.7 on 2023-12-28 01:48

import base.models
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Card',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
            ],
        ),
        migrations.CreateModel(
            name='Game',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mode', models.IntegerField(choices=[(1, 'Strict'), (2, 'Average')], default=1)),
                ('base_task', models.CharField(blank=True, max_length=50, null=True)),
                ('start_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('end_at', models.DateTimeField(blank=True, null=True)),
            ],
            bases=(models.Model, base.models.SingletonMixin),
        ),
        migrations.CreateModel(
            name='Round',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('finished', models.BooleanField(default=False)),
                ('final_vote', models.IntegerField(default=0)),
                ('game', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='base.game')),
            ],
        ),
        migrations.CreateModel(
            name='Task',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=1024, unique=True)),
                ('game', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='base.game')),
            ],
        ),
        migrations.CreateModel(
            name='User',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('username', models.CharField(max_length=150, unique=True)),
                ('order', models.IntegerField(default=0)),
                ('game', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='base.game')),
            ],
            options={
                'ordering': ['order'],
            },
        ),
        migrations.CreateModel(
            name='UserVote',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('vote', models.IntegerField(default=0)),
                ('voted', models.BooleanField(default=False)),
                ('round', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='base.round')),
                ('task', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='base.task')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='base.user')),
            ],
        ),
        migrations.AddField(
            model_name='round',
            name='task',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='base.task'),
        ),
        migrations.AddField(
            model_name='round',
            name='votes',
            field=models.ManyToManyField(blank=True, related_name='round_votes', to='base.uservote'),
        ),
        migrations.AddField(
            model_name='game',
            name='rounds',
            field=models.ManyToManyField(blank=True, related_name='game_rounds', to='base.round'),
        ),
        migrations.AddField(
            model_name='game',
            name='tasks',
            field=models.ManyToManyField(blank=True, related_name='game_tasks', to='base.task'),
        ),
        migrations.AddField(
            model_name='game',
            name='users',
            field=models.ManyToManyField(blank=True, related_name='game_users', to='base.user'),
        ),
    ]
